<?php
/**
 * 2007-2018 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 * @author ScaleDEV <contact@scaledev.fr>
 * @author 202 ecommerce <tech@202-ecommerce.com>
 * @copyright Copyright (c) Mondial Relay
 * @license   http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 * International Registered Trademark & Property of PrestaShop SA
 */

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Upgrades the module.
 *
 * @param MondialRelay $module The module's instance.
 * @return bool
 */
function upgrade_module_2_3_5(MondialRelay $module)
{
    $newVersion = '2.3.5';
    $module->upgrade_detail[$newVersion] = array();

    $query = (
        'ALTER TABLE ' . _DB_PREFIX_ . 'mr_selected'
        . ' MODIFY COLUMN date_add DATETIME NULL DEFAULT CURRENT_TIMESTAMP,'
        . ' MODIFY COLUMN date_upd DATETIME NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP'
    );

    return (bool)Db::getInstance()->execute($query);
}
